#!/bin/bash

#Returns persistant data usage of wan interfaces

#Interface Name
iface=$1
uci_cmd="uci -q"
total_data=0

getDataUsage() {
    network=$1
    RX=`$uci_cmd get ifaces_statistics.$network.rx_bytes`
    TX=`$uci_cmd get ifaces_statistics.$network.tx_bytes`
    data_usage=`expr $RX + $TX`
    echo $data_usage
}

if [ ! -z $iface ]; then
    iface=`uci show ifaces_statistics | grep "ifaces_statistics.*.ifname=\'$iface\'" | cut -d. -f2`
    getDataUsage $iface
else
    ifacesList=$($uci_cmd get ifaces_statistics.config.intf_list)
    IFS=' '
    read -ra arr <<< "$ifacesList"
    for wanIface in "${arr[@]}"; do
        if [ "${wanIface:0:2}" != "wg" ]; then
            datausage=`getDataUsage $wanIface`
            total_data=`expr $datausage + $total_data`
	fi
    done
    echo $total_data
fi

