#!/bin/bash

#This script provides rx and tx bytes usage of data tunnel and control tunnel

#Data tunnel id
tunnel_id=$1
uci_cmd="uci -q"
total_data=0

getDataUsage() {
    network=$1
    RX=`$uci_cmd get ifaces_statistics.$network.rx_bytes`
    TX=`$uci_cmd get ifaces_statistics.$network.tx_bytes`
    data_usage=`expr $RX + $TX`
    echo $data_usage
}

if [ ! -z "$tunnel_id" ]; then
        if [ "$tunnel_id" == "wg0" ]; then
                getDataUsage $tunnel_id
        else
                interfaces=`cat /etc/zabbix_agentd.conf.d/scripts/tunnelStatus.txt | grep -w $tunnel_id | awk '{print $4}'`
                getDataUsage $interfaces
        fi
else
        ifacesList=$($uci_cmd get ifaces_statistics.config.intf_list)
        IFS=' '
        read -ra arr <<< "$ifacesList"
        for Ifaces in "${arr[@]}"; do
                if [ "${Ifaces:0:2}" == "wg" ] && [ "${Ifaces:0:3}" != "wg0" ]; then
                        datausage=`getDataUsage $Ifaces`
                        total_data=`expr $datausage + $total_data`
                fi
        done
        echo $total_data
fi

