#!/bin/bash

#For switching Endpoint IP for control tunnel at the MA wrt mwan3

. /lib/functions.sh "TUNNEL"

#Fetch the Caller Function name and Line number
logInfo() { echo "("${FUNCNAME[1]}":"${BASH_LINENO}")"; }

#Getting the mgmtIP and port details from ztp file
address=`uci -q get ztp.EM_details.domain`
mgmtProto=`uci -q get ztp.EM_details.proto`
if [ $mgmtProto == "https" ]
then
        endpoint_IP=`nslookup $address | grep "Address" | awk 'NR==2 {print $2}'`
else
	endpoint_IP=$address
fi

active_WAN=$1
check_WAN=${active_WAN:0:3}

if [ $check_WAN == "wan" ]
then
   longNotice "$(logInfo)" "The active WAN is $active_WAN"
   uci set network.wg0.nohostroute='1'
   uci set network.wg0.tunlink="$active_WAN"
   uci commit network
   route delete $endpoint_IP
   #Condition to choose the interface based on the active_wan type
   if [ `uci get network.$active_WAN.type` == "bridge" ]
   then
     interface=br-$active_WAN
   else
     interface=`uci get network.$active_WAN.ifname`
   fi
   gateway=`ip route | grep default | grep $interface | awk {'print $3'}`
   metric=`uci get network.$active_WAN.metric`
   ip route get $endpoint_IP | grep via
   if [[ `echo $?` == 0 ]]; then
     ip route add $endpoint_IP via $gateway dev $interface metric $metric
   else
     ip route add $endpoint_IP dev $interface metric $metric
   fi
fi
if [ $check_WAN == "unr" ]
then
   longNotice "$(logInfo)" "The active WAN is $active_WAN"
   route delete $endpoint_IP
   uci set network.wg0.nohostroute="1"
   uci set network.wg0.tunlink=""
   uci commit network
fi
