#!/bin/bash
#This script is used to restore the data tunnel connection after factory reset

. /lib/functions.sh "TUNNEL"

#Fetch the Caller Function name and Line number
logInfo() { echo "("${FUNCNAME[1]}":"${BASH_LINENO}")"; }

factory=''
operid=''
while [ -z $factory ]; do
	factory=`cat /isFactory`
done

if [ $factory == '1' ]
then
	uci set network.wg0=interface
	uci set network.wg0.proto='wireguard'

	WG_KEY="$(cat /opt/inseego/etc/devicePrivateKey)"
	uci set network.wg0.private_key="$WG_KEY"

	tunnelIP=`uci get network_factory.controlTunnel.tunnelIP`
	uci add_list network.wg0.addresses="$tunnelIP"

	uci set network.wg0.listen_port='51820'

	uci set network.controlTunnel=wireguard_wg0

	serverPubkey=`uci get network_factory.controlTunnel.serverPubKey`
	uci set network.controlTunnel.public_key="$serverPubkey"

	presharedKey=`uci -q get network_factory.controlTunnel.preshared_key`
	uci set network.controlTunnel.preshared_key="$presharedKey"

	uci set network.controlTunnel.route_allowed_ips=1

	serverIP=`uci get network_factory.controlTunnel.serverIP`
	uci add_list network.controlTunnel.allowed_ips="$serverIP"

	mgmtIP=`uci get network_factory.controlTunnel.mgmtIP`
	uci set network.controlTunnel.endpoint_host="$mgmtIP"

	uci set network.controlTunnel.endpoint_port="51820"
	uci set network.controlTunnel.persistent_keepalive=25

	uci commit network

        operid="$(cat /operid)"

	rm /etc/config/factorynet
	rm /etc/config/network_factory

	/etc/init.d/network restart
fi
longDebug "$(logInfo)" "Executing ZTP Script with Factory Status=$factory and Operation ID=$operid"
/opt/inseego/bin/ifaces_update.sh start &
bash /opt/inseego/bin/exe_ztp.sh $factory $operid &
echo 0 > /isFactory
