#!/bin/bash

#Returns Network address of a specific Interface.
getNetwork() {
        if ifconfig $interface > /dev/null 2>&1; then
                LanIP=`ifconfig $interface | grep "inet addr" | cut -d ":" -f2 | cut -d " " -f1`
                LanMask=`ifconfig $interface | grep "inet addr" | cut -d ":" -f4 | cut -d " " -f3`
                LanSubnet=`ipcalc.sh $LanIP $LanMask | grep "PREFIX" | cut  -d "=" -f2`
                LanNetwork=`ipcalc.sh $LanIP $LanMask | grep "NETWORK" | cut  -d "=" -f2`
                LanCidr=$LanNetwork/$LanSubnet
                if [ ! "$LanCidr" == "0.0.0.0/0" ]; then
                        echo $LanCidr
                fi
        fi
}
#if interface name is provided as input will return network of that interface
if [ ! -z $1 ] ; then
        interface=$1
        getNetwork $interface
        exit
#Returns Network address of all LAN networks in JSON
else
        list=`echo "{ 'allowedIP': ["`
        network=`uci -q get network.lan_entry.usemember`
        network="$network lan"
        if [ !  -z "$network" ]; then
                IFS=' '
                read -ra array <<< "$network"
                for ifname in "${array[@]}";
                do
                        type=`uci -q get network.$ifname.type`
                        if [ "$type" == "bridge" ]; then
                                interface="br-$ifname"
                        else
                                interface=`uci -q get network.$ifname.ifname`
                        fi
                        if [ ! -z $interface ];then
                                LanCidr=$(getNetwork $interface)
                                if [ -z $LanCidr ]; then
                                        continue;
                                fi
                                list=`echo "$list '$LanCidr',"`
                        fi
                done
        fi
        list=`echo $list | sed '$s/,$//'`
        echo "$list ]}"
fi
