#!/bin/bash

#This script returns the rx and tx dropped packets count for the datatunnel interfaces. 
#The script will execute while zabbix requests for the droprate at a specified interval
if [ "$#" -ne 2 ]; then
    echo "Usage: /etc/zabbix_agentd.conf.d/scripts/datatunnel_droprate.sh <tunnel_id> <packetType>"
    exit
fi
#Tunnel ID of the device
tunnelID=$1
packetType=$2

if [ ! -z "$tunnelID" ]
then
	interface=`cat /etc/zabbix_agentd.conf.d/scripts/tunnelStatus.txt | grep -w $tunnelID | awk '{print $4}'`
	if [ "$packetType" = "rx" ];then
		cat /sys/class/net/$interface/statistics/rx_dropped
	else
		cat /sys/class/net/$interface/statistics/tx_dropped
	fi
else
	echo "Tunnel ID is empty"
fi
