#!/bin/bash

#Converts netmask to Cidr format
IPprefix_by_netmask () {
   cidr=0 x=0$( printf '%o' ${1//./ } )
   while [ $x -gt 0 ]; do
       let cidr+=$((x%2)) 'x>>=1'
   done
   echo $cidr;
}

if [ "$#" -ne 1 ]; then
    echo "Usage: /etc/zabbix_agentd.conf.d/scripts/net_info.sh <interface_name>"
    exit
fi

#Returns the network info of the interface
if ifconfig $1 > /dev/null 2>&1; then
	ipaddress=`ifconfig $1 |grep "inet addr" |cut -d: -f2| cut -d " " -f1`
	netmask=`ifconfig $1 |grep Mask | awk '{print $(NF)}' | cut -d: -f2`
	gateway=`ip route | grep "default.*.$1" | awk '{print $3}' | head -n1`
	subnet=$(IPprefix_by_netmask $netmask)
	netInfo=`echo "{ 'ipAddress': '$ipaddress', 'netmask':'$netmask', 'gateway':'$gateway', 'subnet':'$subnet' }"`
	echo $netInfo
else
	echo "Interface name is not valid"
fi
