#!/bin/bash

Usage() {
	echo "Usage: insg_wan_network.sh [IP Address] [Netmask] [Gateway] [DNS1] [DNS2] [MTU]"
	echo -e "\tIP Address    : IP Address of the network"
	echo -e "\tNetmask         : Specify the interface netmask"
	echo -e "\tGateway       : Gateway address of the Network"
	echo -e "\tDNS1         : Primary DNS Address"
	echo -e "\tDNS2         : Secondary DNS Address"
	echo -e "\tMTU(Optional) : MTU of the network."
	exit
}

if [ $# -lt 5 ]; then
	Usage
fi

ipaddr=$1
netmask=$2
gateway=$3
dns1=$4
dns2=$5
mtu=$6

uci set network.wan.proto='static'
uci set network.wan.ipaddr=$ipaddr
uci set network.wan.netmask=$netmask
uci set network.wan.gateway=$gateway
uci -q del network.wan.dns
uci set network.wan.dns="$dns1 $dns2"
uci set network.wan.peerdns=0
if [ ! -z $mtu ];then
	uci set network.wan.mtu=$mtu
fi
uci commit network
/etc/init.d/network restart
