#!/bin/bash
. /lib/functions.sh "IPSEC MONITOR"

#Fetch the Caller Function name and Line number
logInfo() { echo "("${FUNCNAME[1]}":"${BASH_LINENO}")"; }

file="/etc/ipsec.conf"
restartStatus=0
while :
do
	if ! grep -q "strongSwan IPsec configuration file" "$file" && [ -s "$file" ] ;
	then
		delay=$(cat /etc/ipsec.conf | grep dpddelay | cut -d= -f2 | head -n1)
		retrycount=$((delay / 2))
		count=0
		while [ $count -lt $retrycount ]; do
			sleep 2;
			tunCount=$(cat /etc/ipsec.conf | grep conn | wc -l)
			installCount=$(ipsec status | grep INSTALLED | wc -l)
			if [[ "$installCount" -lt "$tunCount" ]];then
				count=$((count + 1))
			else
				break;
			fi
		done
		if [[ $count == $retrycount ]]; then
			/etc/init.d/ipsec restart
			longInfo "$(logInfo)" "Restarting the IPSec process"
		fi
	else
		sleep 2
	fi
done
