#!/bin/bash

. /lib/functions.sh "Netmon"

#Fetch the Caller Function name and Line number
logInfo() { echo "("${FUNCNAME[1]}":"${BASH_LINENO}")"; }

isSameNetwork() {
    IFS="."
    read -ra curIP <<< "$1"
    read -ra rangeIP <<< "$2"
    read -ra netmask <<< "$3"

    if [[ $(( ${rangeIP[0]}&${netmask[0]} )) == $(( ${curIP[0]}&${netmask[0]} )) ]] && [[ $(( ${rangeIP[1]}&${netmask[1]} )) == $(( ${curIP[1]}&${netmask[1]} )) ]] && [[ $(( ${rangeIP[2]}&${netmask[2]} )) == $(( ${curIP[2]}&${netmask[2]} )) ]] && [[ $(( ${rangeIP[3]}&${netmask[3]} )) == $(( ${curIP[3]}&${netmask[3]} )) ]];then
        echo  true
    else
        echo false
    fi
}

ifaceList=`ifconfig | grep HWaddr | awk '{print $1}' | tr '\n' ' '`
IFS=' '
read -ra arr <<< "$ifaceList"
for iface in "${arr[@]}";
do
    ipaddr=`ifconfig $iface | grep "inet addr" | awk '{print $2}' | cut -d: -f2`
    if [ ! -z $ipaddr ];then
        mask=`ifconfig $iface | grep "Mask" | awk '{print $(NF)}' | cut -d: -f2`
        nwlist=`echo "$iface:$ipaddr/$mask,$nwlist"`
    fi
done

IFS=","
read -ra net <<< "$nwlist"
for ((index = 0 ; index < ${#net[@]} ; index++)); do
    ipAddr1=`echo ${net[$index]} | cut -d: -f2 | cut -d/ -f1`
    ifname1=`echo ${net[$index]} | cut -d: -f1`
    for ((index1 = 0 ; index1 < ${#net[@]} ; index1++)); do
        #Continue if the IP address is array is compared with itself
        if [[ "$index" == "$index1" ]]; then
            continue;
        fi
        netmask=`echo ${net[$index1]} | cut -d'/' -f2`
        ipAddr2=`echo ${net[$index1]} | cut -d':' -f2 | cut -d/ -f1`
        ret=$(isSameNetwork $ipAddr1 $ipAddr2 $netmask)
        if [ "$ret" == "true" ];then
            ifname2=`echo ${net[$index1]} | cut -d: -f1`
            longWarn "$(logInfo)" "Network address of $ifname1 and $ifname2 is same"
        fi
    done
done
