#!/bin/bash

mgmtUrl=$(uci -q get tZTP.ztp.url)
if [ -z "$mgmtUrl" ]; then
        longErr "$(logInfo)" "Edge Manager URL not Found..."
        exit
fi
mgmtPort=$(uci -q get tZTP.ztp.port)
if [ -z "$mgmtPort" ]; then
        longErr "$(logInfo)" "Edge Manager Port not Found..."
        exit
fi
apiKey=$(uci -q get tZTP.ztp.apiKey)
if [ -z "$apiKey" ]; then
    longErr "$(logInfo)" "API Key not Found..."
    exit
fi
tenName=$(uci -q get tZTP.ztp.tenName)
if [ -z "$tenName" ]; then
    longErr "$(logInfo)" "tenName not Found..."
    exit
fi
mgmtUser=$(uci -q get tZTP.ztp.usrName)
if [ -z "$mgmtUser" ]; then
    longErr "$(logInfo)" "Edge Manager User URL not Found..."
    exit
fi
mgmtPass=$(uci -q get tZTP.ztp.password)
if [ -z "$mgmtPass" ]; then
    longErr "$(logInfo)" "Edge Manager Password not Found..."
    exit
fi
certFile=$(uci -q get tZTP.ztp.CertPath)
if [[ ! -f "$certFile" ]]; then
        certFile="/etc/ssl/cert.pem"
fi
timeout=$(uci -q get tZTP.ztp.curlTimeout)
if [ -z "$timeout" -o "$timeout" = "null" ]; then
        timeout=60
fi
retry=$(uci -q get tZTP.ztp.curlRetry)
if [ -z "$retry" -o "$retry" = "null" ]; then
        retry=3
fi
maxtimeout=$(uci -q get tZTP.ztp.curlMaxTimeout)
if [ -z "$maxtimeout" -o "$maxtimeout" = "null" ]; then
        maxtimeout=120
fi
retryDelay=$(uci -q get tZTP.ztp.curlRetryDelay)
if [ -z "$retryDelay" -o "$retryDelay" = "null" ]; then
        retryDelay=5
fi
dwldpkg=$(uci -q get tZTP.ztp.dwldpkg)
if [ -z "$dwldpkg" -o "$dwldpkg" = "null" ]; then
        dwldpkg="False"
fi
allowK=$(uci -q get tZTP.ztp.allowCurlK)

keyFile="/opt/inseego/etc/key"
