#!/bin/bash

. /lib/functions.sh "ZTP"

#Fetch the Caller Function name and Line number
logInfo() { echo "("${FUNCNAME[1]}":"${BASH_LINENO}")"; }


#Configure the error status in ztpStatus file, if the return value is not success
retCheck() {
	ret=$1
	msg=$2
	param=$3
	if [ "$ret" != "0" ]; then
		uci set ztpStatus.@PROCESS_ACTIVATION_CODE[0].error=$msg
		uci set ztpStatus.@PROCESS_ACTIVATION_CODE[0].exError=$param
		uci set ztpStatus.@PROCESS_ACTIVATION_CODE[0].status="FAILURE"
		uci set ztpStatus.@PROCESS_ACTIVATION_CODE[0].timestamp="$(date)"
		uci commit ztpStatus
		rm -rf /tmp/tztp.lock
		longErr "$(logInfo)" "$msg - $param"
		exit
	fi
}
checkMandateInfo() {                                                              
    input=$1                                                                    
    IFS=' '                                                                     
    read -ra arr <<< "$input"                                                   
    for data in "${arr[@]}"; do                                                 
        value=$(uci -q get tZTP.ztp.$data)                               
        if [ -z "$value" -o "$value" = "null" ]; then                           
            retCheck 1 MISSING_MANDATORY_PARAMETER "Error $data missing"
        fi                                                                      
    done                                                                        
}

checkMandateInfo "url port apiKey usrName password devID tenName bootstrapRetry wgMTU"
mac=$(uci -q get tZTP.ztp.devID)
#devmac=$(/bin/insg/commsub_cli modem2_get_info 10 | grep imei: | cut -d "[" -f2 | cut -d "]" -f1)
#if [ "$devimei" != "$imei" ];then
#	retCheck 1 IMEI_NOT_MATCHING "Key IMEI:$imei not matching $devimei"
#fi
dwldstatus=$(uci -q get tZTP.ztp.dwldpkg)
if [ "$dwldstatus" == "True" ]; then
	bash /opt/inseego/bin/ztpCurl.sh 
fi

bash /opt/inseego/bin/exe_ztp.sh &
ret=$?
retCheck $ret UNABLE_START_ZTP_PROCESS
uci set ztpStatus.@PROCESS_ACTIVATION_CODE[0].status="SUCCESS"
uci del ztpStatus.@PROCESS_ACTIVATION_CODE[0].error
uci set ztpStatus.@PROCESS_ACTIVATION_CODE[0].timestamp="$(date)"
uci commit ztpStatus
#Enable syslog to redirect longship logs to logfile
uci set system.longship.syslog='1'
uci commit system
echo "SUCCESS"
rm -rf /tmp/tztp.lock
